/* incoming_nodes.c generated by valac 0.20.1, the Vala compiler
 * generated from incoming_nodes.vala, do not modify */

/*
 *  This file is part of Netsukuku.
 *  (c) Copyright 2011 Luca Dionisi aka lukisi <luca.dionisi@gmail.com>
 *
 *  Netsukuku is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Netsukuku is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Netsukuku.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <netsukuku-rpc.h>
#include <tasklet.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>


#define NETSUKUKU_TYPE_INCOMING_NODE (netsukuku_incoming_node_get_type ())
#define NETSUKUKU_INCOMING_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETSUKUKU_TYPE_INCOMING_NODE, NetsukukuIncomingNode))
#define NETSUKUKU_INCOMING_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETSUKUKU_TYPE_INCOMING_NODE, NetsukukuIncomingNodeClass))
#define NETSUKUKU_IS_INCOMING_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETSUKUKU_TYPE_INCOMING_NODE))
#define NETSUKUKU_IS_INCOMING_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETSUKUKU_TYPE_INCOMING_NODE))
#define NETSUKUKU_INCOMING_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETSUKUKU_TYPE_INCOMING_NODE, NetsukukuIncomingNodeClass))

typedef struct _NetsukukuIncomingNode NetsukukuIncomingNode;
typedef struct _NetsukukuIncomingNodeClass NetsukukuIncomingNodeClass;
typedef struct _NetsukukuIncomingNodePrivate NetsukukuIncomingNodePrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NETSUKUKU_TYPE_INCOMING_NODES (netsukuku_incoming_nodes_get_type ())
#define NETSUKUKU_INCOMING_NODES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETSUKUKU_TYPE_INCOMING_NODES, NetsukukuIncomingNodes))
#define NETSUKUKU_INCOMING_NODES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETSUKUKU_TYPE_INCOMING_NODES, NetsukukuIncomingNodesClass))
#define NETSUKUKU_IS_INCOMING_NODES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETSUKUKU_TYPE_INCOMING_NODES))
#define NETSUKUKU_IS_INCOMING_NODES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETSUKUKU_TYPE_INCOMING_NODES))
#define NETSUKUKU_INCOMING_NODES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETSUKUKU_TYPE_INCOMING_NODES, NetsukukuIncomingNodesClass))

typedef struct _NetsukukuIncomingNodes NetsukukuIncomingNodes;
typedef struct _NetsukukuIncomingNodesClass NetsukukuIncomingNodesClass;
typedef struct _NetsukukuIncomingNodesPrivate NetsukukuIncomingNodesPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NetsukukuIncomingNode {
	GObject parent_instance;
	NetsukukuIncomingNodePrivate * priv;
};

struct _NetsukukuIncomingNodeClass {
	GObjectClass parent_class;
};

struct _NetsukukuIncomingNodePrivate {
	NetsukukuNIP* _nip;
	gint _nodeid;
	TaskletsTimer* _tcapsule;
	GeeList* _macs;
	GeeTreeMap* knowledge;
};

typedef enum  {
	NETSUKUKU_INCOMING_NODES_ERROR_KEY_NOT_FOUND,
	NETSUKUKU_INCOMING_NODES_ERROR_GENERIC
} NetsukukuIncomingNodesError;
#define NETSUKUKU_INCOMING_NODES_ERROR netsukuku_incoming_nodes_error_quark ()
struct _NetsukukuIncomingNodes {
	GObject parent_instance;
	NetsukukuIncomingNodesPrivate * priv;
};

struct _NetsukukuIncomingNodesClass {
	GObjectClass parent_class;
};

struct _NetsukukuIncomingNodesPrivate {
	GeeHashMap* cont;
};


static gpointer netsukuku_incoming_node_parent_class = NULL;
static gpointer netsukuku_incoming_nodes_parent_class = NULL;

GType netsukuku_incoming_node_get_type (void) G_GNUC_CONST;
#define NETSUKUKU_INCOMING_NODE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NETSUKUKU_TYPE_INCOMING_NODE, NetsukukuIncomingNodePrivate))
enum  {
	NETSUKUKU_INCOMING_NODE_DUMMY_PROPERTY,
	NETSUKUKU_INCOMING_NODE_NIP,
	NETSUKUKU_INCOMING_NODE_NODEID,
	NETSUKUKU_INCOMING_NODE_TCAPSULE,
	NETSUKUKU_INCOMING_NODE_MACS
};
NetsukukuIncomingNode* netsukuku_incoming_node_new (NetsukukuNIP* nip, gint nodeid, GeeList* macs, gint* ttl);
NetsukukuIncomingNode* netsukuku_incoming_node_construct (GType object_type, NetsukukuNIP* nip, gint nodeid, GeeList* macs, gint* ttl);
static void netsukuku_incoming_node_set_nip (NetsukukuIncomingNode* self, NetsukukuNIP* value);
static void netsukuku_incoming_node_set_nodeid (NetsukukuIncomingNode* self, gint value);
static void netsukuku_incoming_node_set_macs (NetsukukuIncomingNode* self, GeeList* value);
static void netsukuku_incoming_node_set_tcapsule (NetsukukuIncomingNode* self, TaskletsTimer* value);
void netsukuku_incoming_node_update (NetsukukuIncomingNode* self, GeeList* macs, gint* ttl);
void netsukuku_incoming_node_log_knowledge (NetsukukuIncomingNode* self, gint my_seq_num, NetsukukuRoutesSet* destinations);
NetsukukuRoutesSet* netsukuku_incoming_node_get_knowledge (NetsukukuIncomingNode* self, gint prev_seq_num);
NetsukukuNIP* netsukuku_incoming_node_get_nip (NetsukukuIncomingNode* self);
gint netsukuku_incoming_node_get_nodeid (NetsukukuIncomingNode* self);
TaskletsTimer* netsukuku_incoming_node_get_tcapsule (NetsukukuIncomingNode* self);
GeeList* netsukuku_incoming_node_get_macs (NetsukukuIncomingNode* self);
static void netsukuku_incoming_node_finalize (GObject* obj);
static void _vala_netsukuku_incoming_node_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_netsukuku_incoming_node_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GQuark netsukuku_incoming_nodes_error_quark (void);
GType netsukuku_incoming_nodes_get_type (void) G_GNUC_CONST;
#define NETSUKUKU_INCOMING_NODES_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), NETSUKUKU_TYPE_INCOMING_NODES, NetsukukuIncomingNodesPrivate))
enum  {
	NETSUKUKU_INCOMING_NODES_DUMMY_PROPERTY
};
NetsukukuIncomingNodes* netsukuku_incoming_nodes_new (void);
NetsukukuIncomingNodes* netsukuku_incoming_nodes_construct (GType object_type);
GeeIterator* netsukuku_incoming_nodes_iterator (NetsukukuIncomingNodes* self);
static gchar* netsukuku_incoming_nodes_tnip_nodeid_key (NetsukukuIncomingNodes* self, NetsukukuNIP* key_nip, gint key_nodeid);
static void netsukuku_incoming_nodes_key_tnip_nodeid (NetsukukuIncomingNodes* self, const gchar* key, NetsukukuNIP** key_nip, gint* key_nodeid);
gboolean netsukuku_incoming_nodes_contains (NetsukukuIncomingNodes* self, NetsukukuNIP* nip, gint nodeid);
GeeList* netsukuku_incoming_nodes_get_macs (NetsukukuIncomingNodes* self, NetsukukuNIP* nip, gint nodeid, GError** error);
void netsukuku_incoming_nodes_update (NetsukukuIncomingNodes* self, NetsukukuNIP* nip, gint nodeid, GeeList* macs, gint* ttl);
void netsukuku_incoming_nodes_purge (NetsukukuIncomingNodes* self);
void netsukuku_incoming_nodes_log_knowledge (NetsukukuIncomingNodes* self, NetsukukuNIP* nip, gint nodeid, gint my_seq_num, NetsukukuRoutesSet* destinations, GError** error);
NetsukukuRoutesSet* netsukuku_incoming_nodes_get_knowledge (NetsukukuIncomingNodes* self, NetsukukuNIP* nip, gint nodeid, gint prev_seq_num, GError** error);
static void netsukuku_incoming_nodes_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


NetsukukuIncomingNode* netsukuku_incoming_node_construct (GType object_type, NetsukukuNIP* nip, gint nodeid, GeeList* macs, gint* ttl) {
	NetsukukuIncomingNode * self = NULL;
	NetsukukuNIP* _tmp0_;
	gint _tmp1_;
	GeeList* _tmp2_;
	gint _ttl;
	gint* _tmp3_;
	gint _tmp5_;
	TaskletsTimer* _tmp6_;
	TaskletsTimer* _tmp7_;
	GeeTreeMap* _tmp8_;
	g_return_val_if_fail (nip != NULL, NULL);
	g_return_val_if_fail (macs != NULL, NULL);
	self = (NetsukukuIncomingNode*) g_object_new (object_type, NULL);
	_tmp0_ = nip;
	netsukuku_incoming_node_set_nip (self, _tmp0_);
	_tmp1_ = nodeid;
	netsukuku_incoming_node_set_nodeid (self, _tmp1_);
	_tmp2_ = macs;
	netsukuku_incoming_node_set_macs (self, _tmp2_);
	_ttl = 60000;
	_tmp3_ = ttl;
	if (_tmp3_ != NULL) {
		gint* _tmp4_;
		_tmp4_ = ttl;
		_ttl = *_tmp4_;
	}
	_tmp5_ = _ttl;
	_tmp6_ = tasklets_timer_new ((gint64) _tmp5_);
	_tmp7_ = _tmp6_;
	netsukuku_incoming_node_set_tcapsule (self, _tmp7_);
	_g_object_unref0 (_tmp7_);
	_tmp8_ = gee_tree_map_new (G_TYPE_INT, NULL, NULL, NETSUKUKU_TYPE_ROUTES_SET, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->knowledge);
	self->priv->knowledge = _tmp8_;
	return self;
}


NetsukukuIncomingNode* netsukuku_incoming_node_new (NetsukukuNIP* nip, gint nodeid, GeeList* macs, gint* ttl) {
	return netsukuku_incoming_node_construct (NETSUKUKU_TYPE_INCOMING_NODE, nip, nodeid, macs, ttl);
}


void netsukuku_incoming_node_update (NetsukukuIncomingNode* self, GeeList* macs, gint* ttl) {
	GeeList* _tmp0_;
	gint _ttl;
	gint* _tmp1_;
	gint _tmp3_;
	TaskletsTimer* _tmp4_;
	TaskletsTimer* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (macs != NULL);
	_tmp0_ = macs;
	netsukuku_incoming_node_set_macs (self, _tmp0_);
	_ttl = 60000;
	_tmp1_ = ttl;
	if (_tmp1_ != NULL) {
		gint* _tmp2_;
		_tmp2_ = ttl;
		_ttl = *_tmp2_;
	}
	_tmp3_ = _ttl;
	_tmp4_ = tasklets_timer_new ((gint64) _tmp3_);
	_tmp5_ = _tmp4_;
	netsukuku_incoming_node_set_tcapsule (self, _tmp5_);
	_g_object_unref0 (_tmp5_);
}


void netsukuku_incoming_node_log_knowledge (NetsukukuIncomingNode* self, gint my_seq_num, NetsukukuRoutesSet* destinations) {
	GeeTreeMap* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GeeTreeMap* _tmp25_;
	gint _tmp26_;
	NetsukukuRoutesSet* _tmp27_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (destinations != NULL);
	_tmp0_ = self->priv->knowledge;
	_tmp1_ = gee_map_get_is_empty ((GeeMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		GeeTreeMap* _tmp3_;
		gint _tmp4_;
		gboolean _tmp5_ = FALSE;
		GeeTreeMap* _tmp6_;
		GeeSortedSet* _tmp7_;
		GeeSortedSet* _tmp8_;
		GeeSortedSet* _tmp9_;
		gpointer _tmp10_ = NULL;
		gint _tmp11_;
		gint min_key;
		GeeTreeMap* _tmp12_;
		GeeSortedSet* _tmp13_;
		GeeSortedSet* _tmp14_;
		GeeSortedSet* _tmp15_;
		gpointer _tmp16_ = NULL;
		gint _tmp17_;
		gint max_key;
		gint _tmp18_;
		gint _tmp19_;
		GeeTreeMap* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		_tmp3_ = self->priv->knowledge;
		_tmp4_ = my_seq_num;
		_tmp5_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) _tmp4_));
		if (_tmp5_) {
			return;
		}
		_tmp6_ = self->priv->knowledge;
		_tmp7_ = gee_abstract_sorted_map_get_ascending_keys ((GeeSortedMap*) _tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = _tmp8_;
		_tmp10_ = gee_sorted_set_first (_tmp9_);
		_tmp11_ = (gint) ((gintptr) _tmp10_);
		_g_object_unref0 (_tmp9_);
		min_key = _tmp11_;
		_tmp12_ = self->priv->knowledge;
		_tmp13_ = gee_abstract_sorted_map_get_ascending_keys ((GeeSortedMap*) _tmp12_);
		_tmp14_ = _tmp13_;
		_tmp15_ = _tmp14_;
		_tmp16_ = gee_sorted_set_last (_tmp15_);
		_tmp17_ = (gint) ((gintptr) _tmp16_);
		_g_object_unref0 (_tmp15_);
		max_key = _tmp17_;
		_tmp18_ = my_seq_num;
		_tmp19_ = max_key;
		if (_tmp18_ < _tmp19_) {
			return;
		}
		_tmp20_ = self->priv->knowledge;
		_tmp21_ = gee_abstract_map_get_size ((GeeMap*) _tmp20_);
		_tmp22_ = _tmp21_;
		if (_tmp22_ >= 3) {
			GeeTreeMap* _tmp23_;
			gint _tmp24_;
			_tmp23_ = self->priv->knowledge;
			_tmp24_ = min_key;
			gee_abstract_map_unset ((GeeAbstractMap*) _tmp23_, (gpointer) ((gintptr) _tmp24_), NULL);
		}
	}
	_tmp25_ = self->priv->knowledge;
	_tmp26_ = my_seq_num;
	_tmp27_ = destinations;
	gee_abstract_map_set ((GeeAbstractMap*) _tmp25_, (gpointer) ((gintptr) _tmp26_), _tmp27_);
}


NetsukukuRoutesSet* netsukuku_incoming_node_get_knowledge (NetsukukuIncomingNode* self, gint prev_seq_num) {
	NetsukukuRoutesSet* result = NULL;
	GeeTreeMap* _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->knowledge;
	_tmp1_ = prev_seq_num;
	_tmp2_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) _tmp1_));
	if (_tmp2_) {
		GeeTreeMap* _tmp3_;
		gint _tmp4_;
		gpointer _tmp5_ = NULL;
		_tmp3_ = self->priv->knowledge;
		_tmp4_ = prev_seq_num;
		_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) _tmp4_));
		result = (NetsukukuRoutesSet*) _tmp5_;
		return result;
	} else {
		result = NULL;
		return result;
	}
}


NetsukukuNIP* netsukuku_incoming_node_get_nip (NetsukukuIncomingNode* self) {
	NetsukukuNIP* result;
	NetsukukuNIP* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_nip;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void netsukuku_incoming_node_set_nip (NetsukukuIncomingNode* self, NetsukukuNIP* value) {
	NetsukukuNIP* _tmp0_;
	NetsukukuNIP* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_nip);
	self->priv->_nip = _tmp1_;
	g_object_notify ((GObject *) self, "nip");
}


gint netsukuku_incoming_node_get_nodeid (NetsukukuIncomingNode* self) {
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_nodeid;
	result = _tmp0_;
	return result;
}


static void netsukuku_incoming_node_set_nodeid (NetsukukuIncomingNode* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_nodeid = _tmp0_;
	g_object_notify ((GObject *) self, "nodeid");
}


TaskletsTimer* netsukuku_incoming_node_get_tcapsule (NetsukukuIncomingNode* self) {
	TaskletsTimer* result;
	TaskletsTimer* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_tcapsule;
	result = _tmp0_;
	return result;
}


static void netsukuku_incoming_node_set_tcapsule (NetsukukuIncomingNode* self, TaskletsTimer* value) {
	TaskletsTimer* _tmp0_;
	TaskletsTimer* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_tcapsule);
	self->priv->_tcapsule = _tmp1_;
	g_object_notify ((GObject *) self, "tcapsule");
}


GeeList* netsukuku_incoming_node_get_macs (NetsukukuIncomingNode* self) {
	GeeList* result;
	GeeList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_macs;
	result = _tmp0_;
	return result;
}


static void netsukuku_incoming_node_set_macs (NetsukukuIncomingNode* self, GeeList* value) {
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_macs);
	self->priv->_macs = _tmp1_;
	g_object_notify ((GObject *) self, "macs");
}


static void netsukuku_incoming_node_class_init (NetsukukuIncomingNodeClass * klass) {
	netsukuku_incoming_node_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NetsukukuIncomingNodePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_netsukuku_incoming_node_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_netsukuku_incoming_node_set_property;
	G_OBJECT_CLASS (klass)->finalize = netsukuku_incoming_node_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETSUKUKU_INCOMING_NODE_NIP, g_param_spec_object ("nip", "nip", "nip", NETSUKUKU_TYPE_NIP, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETSUKUKU_INCOMING_NODE_NODEID, g_param_spec_int ("nodeid", "nodeid", "nodeid", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETSUKUKU_INCOMING_NODE_TCAPSULE, g_param_spec_object ("tcapsule", "tcapsule", "tcapsule", TASKLETS_TYPE_TIMER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETSUKUKU_INCOMING_NODE_MACS, g_param_spec_object ("macs", "macs", "macs", GEE_TYPE_LIST, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void netsukuku_incoming_node_instance_init (NetsukukuIncomingNode * self) {
	self->priv = NETSUKUKU_INCOMING_NODE_GET_PRIVATE (self);
}


static void netsukuku_incoming_node_finalize (GObject* obj) {
	NetsukukuIncomingNode * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETSUKUKU_TYPE_INCOMING_NODE, NetsukukuIncomingNode);
	_g_object_unref0 (self->priv->_nip);
	_g_object_unref0 (self->priv->_tcapsule);
	_g_object_unref0 (self->priv->_macs);
	_g_object_unref0 (self->priv->knowledge);
	G_OBJECT_CLASS (netsukuku_incoming_node_parent_class)->finalize (obj);
}


GType netsukuku_incoming_node_get_type (void) {
	static volatile gsize netsukuku_incoming_node_type_id__volatile = 0;
	if (g_once_init_enter (&netsukuku_incoming_node_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NetsukukuIncomingNodeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) netsukuku_incoming_node_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetsukukuIncomingNode), 0, (GInstanceInitFunc) netsukuku_incoming_node_instance_init, NULL };
		GType netsukuku_incoming_node_type_id;
		netsukuku_incoming_node_type_id = g_type_register_static (G_TYPE_OBJECT, "NetsukukuIncomingNode", &g_define_type_info, 0);
		g_once_init_leave (&netsukuku_incoming_node_type_id__volatile, netsukuku_incoming_node_type_id);
	}
	return netsukuku_incoming_node_type_id__volatile;
}


static void _vala_netsukuku_incoming_node_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	NetsukukuIncomingNode * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETSUKUKU_TYPE_INCOMING_NODE, NetsukukuIncomingNode);
	switch (property_id) {
		case NETSUKUKU_INCOMING_NODE_NIP:
		g_value_set_object (value, netsukuku_incoming_node_get_nip (self));
		break;
		case NETSUKUKU_INCOMING_NODE_NODEID:
		g_value_set_int (value, netsukuku_incoming_node_get_nodeid (self));
		break;
		case NETSUKUKU_INCOMING_NODE_TCAPSULE:
		g_value_set_object (value, netsukuku_incoming_node_get_tcapsule (self));
		break;
		case NETSUKUKU_INCOMING_NODE_MACS:
		g_value_set_object (value, netsukuku_incoming_node_get_macs (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_netsukuku_incoming_node_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	NetsukukuIncomingNode * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETSUKUKU_TYPE_INCOMING_NODE, NetsukukuIncomingNode);
	switch (property_id) {
		case NETSUKUKU_INCOMING_NODE_NIP:
		netsukuku_incoming_node_set_nip (self, g_value_get_object (value));
		break;
		case NETSUKUKU_INCOMING_NODE_NODEID:
		netsukuku_incoming_node_set_nodeid (self, g_value_get_int (value));
		break;
		case NETSUKUKU_INCOMING_NODE_TCAPSULE:
		netsukuku_incoming_node_set_tcapsule (self, g_value_get_object (value));
		break;
		case NETSUKUKU_INCOMING_NODE_MACS:
		netsukuku_incoming_node_set_macs (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


GQuark netsukuku_incoming_nodes_error_quark (void) {
	return g_quark_from_static_string ("netsukuku_incoming_nodes_error-quark");
}


NetsukukuIncomingNodes* netsukuku_incoming_nodes_construct (GType object_type) {
	NetsukukuIncomingNodes * self = NULL;
	GeeHashMap* _tmp0_;
	self = (NetsukukuIncomingNodes*) g_object_new (object_type, NULL);
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NETSUKUKU_TYPE_INCOMING_NODE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->cont);
	self->priv->cont = _tmp0_;
	return self;
}


NetsukukuIncomingNodes* netsukuku_incoming_nodes_new (void) {
	return netsukuku_incoming_nodes_construct (NETSUKUKU_TYPE_INCOMING_NODES);
}


GeeIterator* netsukuku_incoming_nodes_iterator (NetsukukuIncomingNodes* self) {
	GeeIterator* result = NULL;
	GeeHashMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeIterator* _tmp4_ = NULL;
	GeeIterator* _tmp5_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->cont;
	_tmp1_ = gee_abstract_map_get_values ((GeeMap*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
	_tmp5_ = _tmp4_;
	_g_object_unref0 (_tmp3_);
	result = _tmp5_;
	return result;
}


static gchar* netsukuku_incoming_nodes_tnip_nodeid_key (NetsukukuIncomingNodes* self, NetsukukuNIP* key_nip, gint key_nodeid) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* ret;
	NetsukukuNIP* _tmp1_;
	gint _tmp2_ = 0;
	gint* _tmp3_ = NULL;
	gint* nip;
	gint nip_length1;
	gint _nip_size_;
	gint* _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp10_;
	gint _tmp11_;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_;
	gchar* _tmp14_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (key_nip != NULL, NULL);
	_tmp0_ = g_strdup ("");
	ret = _tmp0_;
	_tmp1_ = key_nip;
	_tmp3_ = netsukuku_partial_nip_get_positions ((NetsukukuPartialNIP*) _tmp1_, &_tmp2_);
	nip = _tmp3_;
	nip_length1 = _tmp2_;
	_nip_size_ = nip_length1;
	_tmp4_ = nip;
	_tmp4__length1 = nip_length1;
	{
		gint* i_collection = NULL;
		gint i_collection_length1 = 0;
		gint _i_collection_size_ = 0;
		gint i_it = 0;
		i_collection = _tmp4_;
		i_collection_length1 = _tmp4__length1;
		for (i_it = 0; i_it < _tmp4__length1; i_it = i_it + 1) {
			gint i = 0;
			i = i_collection[i_it];
			{
				const gchar* _tmp5_;
				gint _tmp6_;
				gchar* _tmp7_ = NULL;
				gchar* _tmp8_;
				gchar* _tmp9_;
				_tmp5_ = ret;
				_tmp6_ = i;
				_tmp7_ = g_strdup_printf ("%d_", _tmp6_);
				_tmp8_ = _tmp7_;
				_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
				_g_free0 (ret);
				ret = _tmp9_;
				_g_free0 (_tmp8_);
			}
		}
	}
	_tmp10_ = ret;
	_tmp11_ = key_nodeid;
	_tmp12_ = g_strdup_printf ("%d", _tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = g_strconcat (_tmp10_, _tmp13_, NULL);
	_g_free0 (ret);
	ret = _tmp14_;
	_g_free0 (_tmp13_);
	result = ret;
	nip = (g_free (nip), NULL);
	return result;
}


static void netsukuku_incoming_nodes_key_tnip_nodeid (NetsukukuIncomingNodes* self, const gchar* key, NetsukukuNIP** key_nip, gint* key_nodeid) {
	NetsukukuNIP* _vala_key_nip = NULL;
	gint _vala_key_nodeid = 0;
	const gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_ = NULL;
	gchar** nums;
	gint nums_length1;
	gint _nums_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gint* _tmp4_ = NULL;
	gint* pos;
	gint pos_length1;
	gint _pos_size_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	gchar** _tmp18_;
	gint _tmp18__length1;
	const gchar* _tmp19_;
	gint _tmp20_ = 0;
	gint* _tmp21_;
	gint _tmp21__length1;
	NetsukukuNIP* _tmp22_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (key != NULL);
	_tmp0_ = key;
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, "_", 0);
	nums = _tmp2_;
	nums_length1 = _vala_array_length (_tmp1_);
	_nums_size_ = nums_length1;
	_tmp3_ = nums;
	_tmp3__length1 = nums_length1;
	_tmp4_ = g_new0 (gint, _tmp3__length1 - 1);
	pos = _tmp4_;
	pos_length1 = _tmp3__length1 - 1;
	_pos_size_ = pos_length1;
	{
		gint i;
		i = 0;
		{
			gboolean _tmp5_;
			_tmp5_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_;
				gint _tmp8_;
				gint* _tmp9_;
				gint _tmp9__length1;
				gint* _tmp10_;
				gint _tmp10__length1;
				gint _tmp11_;
				gchar** _tmp12_;
				gint _tmp12__length1;
				gint _tmp13_;
				const gchar* _tmp14_;
				gint _tmp15_ = 0;
				gint _tmp16_;
				_tmp6_ = _tmp5_;
				if (!_tmp6_) {
					gint _tmp7_;
					_tmp7_ = i;
					i = _tmp7_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp8_ = i;
				_tmp9_ = pos;
				_tmp9__length1 = pos_length1;
				if (!(_tmp8_ < _tmp9__length1)) {
					break;
				}
				_tmp10_ = pos;
				_tmp10__length1 = pos_length1;
				_tmp11_ = i;
				_tmp12_ = nums;
				_tmp12__length1 = nums_length1;
				_tmp13_ = i;
				_tmp14_ = _tmp12_[_tmp13_];
				_tmp15_ = atoi (_tmp14_);
				_tmp10_[_tmp11_] = _tmp15_;
				_tmp16_ = _tmp10_[_tmp11_];
			}
		}
	}
	_tmp17_ = nums;
	_tmp17__length1 = nums_length1;
	_tmp18_ = nums;
	_tmp18__length1 = nums_length1;
	_tmp19_ = _tmp17_[_tmp18__length1 - 1];
	_tmp20_ = atoi (_tmp19_);
	_vala_key_nodeid = _tmp20_;
	_tmp21_ = pos;
	_tmp21__length1 = pos_length1;
	_tmp22_ = netsukuku_nip_new (_tmp21_, _tmp21__length1);
	_g_object_unref0 (_vala_key_nip);
	_vala_key_nip = _tmp22_;
	pos = (g_free (pos), NULL);
	nums = (_vala_array_free (nums, nums_length1, (GDestroyNotify) g_free), NULL);
	if (key_nip) {
		*key_nip = _vala_key_nip;
	} else {
		_g_object_unref0 (_vala_key_nip);
	}
	if (key_nodeid) {
		*key_nodeid = _vala_key_nodeid;
	}
}


gboolean netsukuku_incoming_nodes_contains (NetsukukuIncomingNodes* self, NetsukukuNIP* nip, gint nodeid) {
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
	NetsukukuNIP* _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (nip != NULL, FALSE);
	_tmp0_ = self->priv->cont;
	_tmp1_ = nip;
	_tmp2_ = nodeid;
	_tmp3_ = netsukuku_incoming_nodes_tnip_nodeid_key (self, _tmp1_, _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp4_);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	result = _tmp6_;
	return result;
}


GeeList* netsukuku_incoming_nodes_get_macs (NetsukukuIncomingNodes* self, NetsukukuNIP* nip, gint nodeid, GError** error) {
	GeeList* result = NULL;
	NetsukukuNIP* _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* k;
	GeeHashMap* _tmp3_;
	const gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	GeeHashMap* _tmp7_;
	const gchar* _tmp8_;
	gpointer _tmp9_ = NULL;
	NetsukukuIncomingNode* _tmp10_;
	GeeList* _tmp11_;
	GeeList* _tmp12_;
	GeeList* _tmp13_;
	GeeList* _tmp14_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (nip != NULL, NULL);
	_tmp0_ = nip;
	_tmp1_ = nodeid;
	_tmp2_ = netsukuku_incoming_nodes_tnip_nodeid_key (self, _tmp0_, _tmp1_);
	k = _tmp2_;
	_tmp3_ = self->priv->cont;
	_tmp4_ = k;
	_tmp5_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, _tmp4_);
	if (!_tmp5_) {
		GError* _tmp6_;
		_tmp6_ = g_error_new_literal (NETSUKUKU_INCOMING_NODES_ERROR, NETSUKUKU_INCOMING_NODES_ERROR_KEY_NOT_FOUND, "IncomingNode not present");
		_inner_error_ = _tmp6_;
		if (_inner_error_->domain == NETSUKUKU_INCOMING_NODES_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (k);
			return NULL;
		} else {
			_g_free0 (k);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp7_ = self->priv->cont;
	_tmp8_ = k;
	_tmp9_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, _tmp8_);
	_tmp10_ = (NetsukukuIncomingNode*) _tmp9_;
	_tmp11_ = netsukuku_incoming_node_get_macs (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = _g_object_ref0 (_tmp12_);
	_tmp14_ = _tmp13_;
	_g_object_unref0 (_tmp10_);
	result = _tmp14_;
	_g_free0 (k);
	return result;
}


void netsukuku_incoming_nodes_update (NetsukukuIncomingNodes* self, NetsukukuNIP* nip, gint nodeid, GeeList* macs, gint* ttl) {
	NetsukukuNIP* _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* k;
	GeeArrayList* _tmp3_;
	GeeArrayList* to_send_event;
	GeeHashMap* _tmp4_;
	const gchar* _tmp5_;
	gboolean _tmp6_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (nip != NULL);
	g_return_if_fail (macs != NULL);
	_tmp0_ = nip;
	_tmp1_ = nodeid;
	_tmp2_ = netsukuku_incoming_nodes_tnip_nodeid_key (self, _tmp0_, _tmp1_);
	k = _tmp2_;
	_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
	to_send_event = _tmp3_;
	_tmp4_ = self->priv->cont;
	_tmp5_ = k;
	_tmp6_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp4_, _tmp5_);
	if (_tmp6_) {
		GeeArrayList* _tmp51_;
		GeeArrayList* macs_clone;
		GeeHashMap* _tmp65_;
		const gchar* _tmp66_;
		gpointer _tmp67_ = NULL;
		NetsukukuIncomingNode* _tmp68_;
		GeeArrayList* _tmp69_;
		gint* _tmp70_;
		{
			GeeList* _tmp7_;
			GeeList* _tmp8_;
			GeeList* _mac_list;
			GeeList* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			gint _mac_size;
			gint _mac_index;
			_tmp7_ = macs;
			_tmp8_ = _g_object_ref0 (_tmp7_);
			_mac_list = _tmp8_;
			_tmp9_ = _mac_list;
			_tmp10_ = gee_collection_get_size ((GeeCollection*) _tmp9_);
			_tmp11_ = _tmp10_;
			_mac_size = _tmp11_;
			_mac_index = -1;
			while (TRUE) {
				gint _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				GeeList* _tmp15_;
				gint _tmp16_;
				gpointer _tmp17_ = NULL;
				gchar* mac;
				GeeHashMap* _tmp18_;
				const gchar* _tmp19_;
				gpointer _tmp20_ = NULL;
				NetsukukuIncomingNode* _tmp21_;
				GeeList* _tmp22_;
				GeeList* _tmp23_;
				const gchar* _tmp24_;
				gboolean _tmp25_ = FALSE;
				gboolean _tmp26_;
				_tmp12_ = _mac_index;
				_mac_index = _tmp12_ + 1;
				_tmp13_ = _mac_index;
				_tmp14_ = _mac_size;
				if (!(_tmp13_ < _tmp14_)) {
					break;
				}
				_tmp15_ = _mac_list;
				_tmp16_ = _mac_index;
				_tmp17_ = gee_list_get (_tmp15_, _tmp16_);
				mac = (gchar*) _tmp17_;
				_tmp18_ = self->priv->cont;
				_tmp19_ = k;
				_tmp20_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp18_, _tmp19_);
				_tmp21_ = (NetsukukuIncomingNode*) _tmp20_;
				_tmp22_ = netsukuku_incoming_node_get_macs (_tmp21_);
				_tmp23_ = _tmp22_;
				_tmp24_ = mac;
				_tmp25_ = gee_collection_contains ((GeeCollection*) _tmp23_, _tmp24_);
				_tmp26_ = !_tmp25_;
				_g_object_unref0 (_tmp21_);
				if (_tmp26_) {
					GeeArrayList* _tmp27_;
					const gchar* _tmp28_;
					_tmp27_ = to_send_event;
					_tmp28_ = mac;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp27_, _tmp28_);
				}
				_g_free0 (mac);
			}
			_g_object_unref0 (_mac_list);
		}
		{
			GeeHashMap* _tmp29_;
			const gchar* _tmp30_;
			gpointer _tmp31_ = NULL;
			NetsukukuIncomingNode* _tmp32_;
			GeeList* _tmp33_;
			GeeList* _tmp34_;
			GeeList* _tmp35_;
			GeeList* _tmp36_;
			GeeList* _mac_list;
			GeeList* _tmp37_;
			gint _tmp38_;
			gint _tmp39_;
			gint _mac_size;
			gint _mac_index;
			_tmp29_ = self->priv->cont;
			_tmp30_ = k;
			_tmp31_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp29_, _tmp30_);
			_tmp32_ = (NetsukukuIncomingNode*) _tmp31_;
			_tmp33_ = netsukuku_incoming_node_get_macs (_tmp32_);
			_tmp34_ = _tmp33_;
			_tmp35_ = _g_object_ref0 (_tmp34_);
			_tmp36_ = _tmp35_;
			_g_object_unref0 (_tmp32_);
			_mac_list = _tmp36_;
			_tmp37_ = _mac_list;
			_tmp38_ = gee_collection_get_size ((GeeCollection*) _tmp37_);
			_tmp39_ = _tmp38_;
			_mac_size = _tmp39_;
			_mac_index = -1;
			while (TRUE) {
				gint _tmp40_;
				gint _tmp41_;
				gint _tmp42_;
				GeeList* _tmp43_;
				gint _tmp44_;
				gpointer _tmp45_ = NULL;
				gchar* mac;
				GeeList* _tmp46_;
				const gchar* _tmp47_;
				gboolean _tmp48_ = FALSE;
				_tmp40_ = _mac_index;
				_mac_index = _tmp40_ + 1;
				_tmp41_ = _mac_index;
				_tmp42_ = _mac_size;
				if (!(_tmp41_ < _tmp42_)) {
					break;
				}
				_tmp43_ = _mac_list;
				_tmp44_ = _mac_index;
				_tmp45_ = gee_list_get (_tmp43_, _tmp44_);
				mac = (gchar*) _tmp45_;
				_tmp46_ = macs;
				_tmp47_ = mac;
				_tmp48_ = gee_collection_contains ((GeeCollection*) _tmp46_, _tmp47_);
				if (!_tmp48_) {
					GeeArrayList* _tmp49_;
					const gchar* _tmp50_;
					_tmp49_ = to_send_event;
					_tmp50_ = mac;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp49_, _tmp50_);
				}
				_g_free0 (mac);
			}
			_g_object_unref0 (_mac_list);
		}
		_tmp51_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
		macs_clone = _tmp51_;
		{
			GeeList* _tmp52_;
			GeeList* _tmp53_;
			GeeList* _mac_list;
			GeeList* _tmp54_;
			gint _tmp55_;
			gint _tmp56_;
			gint _mac_size;
			gint _mac_index;
			_tmp52_ = macs;
			_tmp53_ = _g_object_ref0 (_tmp52_);
			_mac_list = _tmp53_;
			_tmp54_ = _mac_list;
			_tmp55_ = gee_collection_get_size ((GeeCollection*) _tmp54_);
			_tmp56_ = _tmp55_;
			_mac_size = _tmp56_;
			_mac_index = -1;
			while (TRUE) {
				gint _tmp57_;
				gint _tmp58_;
				gint _tmp59_;
				GeeList* _tmp60_;
				gint _tmp61_;
				gpointer _tmp62_ = NULL;
				gchar* mac;
				GeeArrayList* _tmp63_;
				const gchar* _tmp64_;
				_tmp57_ = _mac_index;
				_mac_index = _tmp57_ + 1;
				_tmp58_ = _mac_index;
				_tmp59_ = _mac_size;
				if (!(_tmp58_ < _tmp59_)) {
					break;
				}
				_tmp60_ = _mac_list;
				_tmp61_ = _mac_index;
				_tmp62_ = gee_list_get (_tmp60_, _tmp61_);
				mac = (gchar*) _tmp62_;
				_tmp63_ = macs_clone;
				_tmp64_ = mac;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp63_, _tmp64_);
				_g_free0 (mac);
			}
			_g_object_unref0 (_mac_list);
		}
		_tmp65_ = self->priv->cont;
		_tmp66_ = k;
		_tmp67_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp65_, _tmp66_);
		_tmp68_ = (NetsukukuIncomingNode*) _tmp67_;
		_tmp69_ = macs_clone;
		_tmp70_ = ttl;
		netsukuku_incoming_node_update (_tmp68_, (GeeList*) _tmp69_, _tmp70_);
		_g_object_unref0 (_tmp68_);
		_g_object_unref0 (macs_clone);
	} else {
		GeeArrayList* _tmp84_;
		GeeArrayList* macs_clone;
		GeeHashMap* _tmp98_;
		const gchar* _tmp99_;
		NetsukukuNIP* _tmp100_;
		gint _tmp101_;
		GeeArrayList* _tmp102_;
		gint* _tmp103_;
		NetsukukuIncomingNode* _tmp104_;
		NetsukukuIncomingNode* _tmp105_;
		{
			GeeList* _tmp71_;
			GeeList* _tmp72_;
			GeeList* _mac_list;
			GeeList* _tmp73_;
			gint _tmp74_;
			gint _tmp75_;
			gint _mac_size;
			gint _mac_index;
			_tmp71_ = macs;
			_tmp72_ = _g_object_ref0 (_tmp71_);
			_mac_list = _tmp72_;
			_tmp73_ = _mac_list;
			_tmp74_ = gee_collection_get_size ((GeeCollection*) _tmp73_);
			_tmp75_ = _tmp74_;
			_mac_size = _tmp75_;
			_mac_index = -1;
			while (TRUE) {
				gint _tmp76_;
				gint _tmp77_;
				gint _tmp78_;
				GeeList* _tmp79_;
				gint _tmp80_;
				gpointer _tmp81_ = NULL;
				gchar* mac;
				GeeArrayList* _tmp82_;
				const gchar* _tmp83_;
				_tmp76_ = _mac_index;
				_mac_index = _tmp76_ + 1;
				_tmp77_ = _mac_index;
				_tmp78_ = _mac_size;
				if (!(_tmp77_ < _tmp78_)) {
					break;
				}
				_tmp79_ = _mac_list;
				_tmp80_ = _mac_index;
				_tmp81_ = gee_list_get (_tmp79_, _tmp80_);
				mac = (gchar*) _tmp81_;
				_tmp82_ = to_send_event;
				_tmp83_ = mac;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp82_, _tmp83_);
				_g_free0 (mac);
			}
			_g_object_unref0 (_mac_list);
		}
		_tmp84_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
		macs_clone = _tmp84_;
		{
			GeeList* _tmp85_;
			GeeList* _tmp86_;
			GeeList* _mac_list;
			GeeList* _tmp87_;
			gint _tmp88_;
			gint _tmp89_;
			gint _mac_size;
			gint _mac_index;
			_tmp85_ = macs;
			_tmp86_ = _g_object_ref0 (_tmp85_);
			_mac_list = _tmp86_;
			_tmp87_ = _mac_list;
			_tmp88_ = gee_collection_get_size ((GeeCollection*) _tmp87_);
			_tmp89_ = _tmp88_;
			_mac_size = _tmp89_;
			_mac_index = -1;
			while (TRUE) {
				gint _tmp90_;
				gint _tmp91_;
				gint _tmp92_;
				GeeList* _tmp93_;
				gint _tmp94_;
				gpointer _tmp95_ = NULL;
				gchar* mac;
				GeeArrayList* _tmp96_;
				const gchar* _tmp97_;
				_tmp90_ = _mac_index;
				_mac_index = _tmp90_ + 1;
				_tmp91_ = _mac_index;
				_tmp92_ = _mac_size;
				if (!(_tmp91_ < _tmp92_)) {
					break;
				}
				_tmp93_ = _mac_list;
				_tmp94_ = _mac_index;
				_tmp95_ = gee_list_get (_tmp93_, _tmp94_);
				mac = (gchar*) _tmp95_;
				_tmp96_ = macs_clone;
				_tmp97_ = mac;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp96_, _tmp97_);
				_g_free0 (mac);
			}
			_g_object_unref0 (_mac_list);
		}
		_tmp98_ = self->priv->cont;
		_tmp99_ = k;
		_tmp100_ = nip;
		_tmp101_ = nodeid;
		_tmp102_ = macs_clone;
		_tmp103_ = ttl;
		_tmp104_ = netsukuku_incoming_node_new (_tmp100_, _tmp101_, (GeeList*) _tmp102_, _tmp103_);
		_tmp105_ = _tmp104_;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp98_, _tmp99_, _tmp105_);
		_g_object_unref0 (_tmp105_);
		_g_object_unref0 (macs_clone);
	}
	{
		GeeArrayList* _tmp106_;
		GeeArrayList* _tmp107_;
		GeeArrayList* _mac_list;
		GeeArrayList* _tmp108_;
		gint _tmp109_;
		gint _tmp110_;
		gint _mac_size;
		gint _mac_index;
		_tmp106_ = to_send_event;
		_tmp107_ = _g_object_ref0 (_tmp106_);
		_mac_list = _tmp107_;
		_tmp108_ = _mac_list;
		_tmp109_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp108_);
		_tmp110_ = _tmp109_;
		_mac_size = _tmp110_;
		_mac_index = -1;
		while (TRUE) {
			gint _tmp111_;
			gint _tmp112_;
			gint _tmp113_;
			GeeArrayList* _tmp114_;
			gint _tmp115_;
			gpointer _tmp116_ = NULL;
			gchar* mac;
			const gchar* _tmp117_;
			_tmp111_ = _mac_index;
			_mac_index = _tmp111_ + 1;
			_tmp112_ = _mac_index;
			_tmp113_ = _mac_size;
			if (!(_tmp112_ < _tmp113_)) {
				break;
			}
			_tmp114_ = _mac_list;
			_tmp115_ = _mac_index;
			_tmp116_ = gee_abstract_list_get ((GeeAbstractList*) _tmp114_, _tmp115_);
			mac = (gchar*) _tmp116_;
			_tmp117_ = mac;
			g_signal_emit_by_name (self, "incoming-node-updated", _tmp117_);
			_g_free0 (mac);
		}
		_g_object_unref0 (_mac_list);
	}
	_g_object_unref0 (to_send_event);
	_g_free0 (k);
}


void netsukuku_incoming_nodes_purge (NetsukukuIncomingNodes* self) {
	GeeArrayList* _tmp0_;
	GeeArrayList* to_send_event;
	GeeArrayList* _tmp1_;
	GeeArrayList* cont_keys;
	g_return_if_fail (self != NULL);
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
	to_send_event = _tmp0_;
	_tmp1_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
	cont_keys = _tmp1_;
	{
		GeeHashMap* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeIterator* _tmp6_ = NULL;
		GeeIterator* _tmp7_;
		GeeIterator* _k_it;
		_tmp2_ = self->priv->cont;
		_tmp3_ = gee_abstract_map_get_keys ((GeeMap*) _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = _tmp4_;
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
		_tmp7_ = _tmp6_;
		_g_object_unref0 (_tmp5_);
		_k_it = _tmp7_;
		while (TRUE) {
			GeeIterator* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GeeIterator* _tmp10_;
			gpointer _tmp11_ = NULL;
			gchar* k;
			GeeArrayList* _tmp12_;
			const gchar* _tmp13_;
			_tmp8_ = _k_it;
			_tmp9_ = gee_iterator_next (_tmp8_);
			if (!_tmp9_) {
				break;
			}
			_tmp10_ = _k_it;
			_tmp11_ = gee_iterator_get (_tmp10_);
			k = (gchar*) _tmp11_;
			_tmp12_ = cont_keys;
			_tmp13_ = k;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
			_g_free0 (k);
		}
		_g_object_unref0 (_k_it);
	}
	{
		GeeArrayList* _tmp14_;
		GeeArrayList* _tmp15_;
		GeeArrayList* _k_list;
		GeeArrayList* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		gint _k_size;
		gint _k_index;
		_tmp14_ = cont_keys;
		_tmp15_ = _g_object_ref0 (_tmp14_);
		_k_list = _tmp15_;
		_tmp16_ = _k_list;
		_tmp17_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp16_);
		_tmp18_ = _tmp17_;
		_k_size = _tmp18_;
		_k_index = -1;
		while (TRUE) {
			gint _tmp19_;
			gint _tmp20_;
			gint _tmp21_;
			GeeArrayList* _tmp22_;
			gint _tmp23_;
			gpointer _tmp24_ = NULL;
			gchar* k;
			GeeHashMap* _tmp25_;
			const gchar* _tmp26_;
			gpointer _tmp27_ = NULL;
			NetsukukuIncomingNode* _tmp28_;
			TaskletsTimer* _tmp29_;
			TaskletsTimer* _tmp30_;
			gboolean _tmp31_ = FALSE;
			gboolean _tmp32_;
			_tmp19_ = _k_index;
			_k_index = _tmp19_ + 1;
			_tmp20_ = _k_index;
			_tmp21_ = _k_size;
			if (!(_tmp20_ < _tmp21_)) {
				break;
			}
			_tmp22_ = _k_list;
			_tmp23_ = _k_index;
			_tmp24_ = gee_abstract_list_get ((GeeAbstractList*) _tmp22_, _tmp23_);
			k = (gchar*) _tmp24_;
			_tmp25_ = self->priv->cont;
			_tmp26_ = k;
			_tmp27_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp25_, _tmp26_);
			_tmp28_ = (NetsukukuIncomingNode*) _tmp27_;
			_tmp29_ = netsukuku_incoming_node_get_tcapsule (_tmp28_);
			_tmp30_ = _tmp29_;
			_tmp31_ = tasklets_timer_is_expired (_tmp30_);
			_tmp32_ = _tmp31_;
			_g_object_unref0 (_tmp28_);
			if (_tmp32_) {
				GeeHashMap* _tmp55_;
				const gchar* _tmp56_;
				{
					GeeHashMap* _tmp33_;
					const gchar* _tmp34_;
					gpointer _tmp35_ = NULL;
					NetsukukuIncomingNode* _tmp36_;
					GeeList* _tmp37_;
					GeeList* _tmp38_;
					GeeList* _tmp39_;
					GeeList* _tmp40_;
					GeeList* _mac_list;
					GeeList* _tmp41_;
					gint _tmp42_;
					gint _tmp43_;
					gint _mac_size;
					gint _mac_index;
					_tmp33_ = self->priv->cont;
					_tmp34_ = k;
					_tmp35_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp33_, _tmp34_);
					_tmp36_ = (NetsukukuIncomingNode*) _tmp35_;
					_tmp37_ = netsukuku_incoming_node_get_macs (_tmp36_);
					_tmp38_ = _tmp37_;
					_tmp39_ = _g_object_ref0 (_tmp38_);
					_tmp40_ = _tmp39_;
					_g_object_unref0 (_tmp36_);
					_mac_list = _tmp40_;
					_tmp41_ = _mac_list;
					_tmp42_ = gee_collection_get_size ((GeeCollection*) _tmp41_);
					_tmp43_ = _tmp42_;
					_mac_size = _tmp43_;
					_mac_index = -1;
					while (TRUE) {
						gint _tmp44_;
						gint _tmp45_;
						gint _tmp46_;
						GeeList* _tmp47_;
						gint _tmp48_;
						gpointer _tmp49_ = NULL;
						gchar* mac;
						GeeArrayList* _tmp50_;
						const gchar* _tmp51_;
						gboolean _tmp52_ = FALSE;
						_tmp44_ = _mac_index;
						_mac_index = _tmp44_ + 1;
						_tmp45_ = _mac_index;
						_tmp46_ = _mac_size;
						if (!(_tmp45_ < _tmp46_)) {
							break;
						}
						_tmp47_ = _mac_list;
						_tmp48_ = _mac_index;
						_tmp49_ = gee_list_get (_tmp47_, _tmp48_);
						mac = (gchar*) _tmp49_;
						_tmp50_ = to_send_event;
						_tmp51_ = mac;
						_tmp52_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp50_, _tmp51_);
						if (!_tmp52_) {
							GeeArrayList* _tmp53_;
							const gchar* _tmp54_;
							_tmp53_ = to_send_event;
							_tmp54_ = mac;
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp53_, _tmp54_);
						}
						_g_free0 (mac);
					}
					_g_object_unref0 (_mac_list);
				}
				_tmp55_ = self->priv->cont;
				_tmp56_ = k;
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp55_, _tmp56_, NULL);
			}
			_g_free0 (k);
		}
		_g_object_unref0 (_k_list);
	}
	{
		GeeArrayList* _tmp57_;
		GeeArrayList* _tmp58_;
		GeeArrayList* _mac_list;
		GeeArrayList* _tmp59_;
		gint _tmp60_;
		gint _tmp61_;
		gint _mac_size;
		gint _mac_index;
		_tmp57_ = to_send_event;
		_tmp58_ = _g_object_ref0 (_tmp57_);
		_mac_list = _tmp58_;
		_tmp59_ = _mac_list;
		_tmp60_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp59_);
		_tmp61_ = _tmp60_;
		_mac_size = _tmp61_;
		_mac_index = -1;
		while (TRUE) {
			gint _tmp62_;
			gint _tmp63_;
			gint _tmp64_;
			GeeArrayList* _tmp65_;
			gint _tmp66_;
			gpointer _tmp67_ = NULL;
			gchar* mac;
			const gchar* _tmp68_;
			_tmp62_ = _mac_index;
			_mac_index = _tmp62_ + 1;
			_tmp63_ = _mac_index;
			_tmp64_ = _mac_size;
			if (!(_tmp63_ < _tmp64_)) {
				break;
			}
			_tmp65_ = _mac_list;
			_tmp66_ = _mac_index;
			_tmp67_ = gee_abstract_list_get ((GeeAbstractList*) _tmp65_, _tmp66_);
			mac = (gchar*) _tmp67_;
			_tmp68_ = mac;
			g_signal_emit_by_name (self, "incoming-node-updated", _tmp68_);
			_g_free0 (mac);
		}
		_g_object_unref0 (_mac_list);
	}
	_g_object_unref0 (cont_keys);
	_g_object_unref0 (to_send_event);
}


void netsukuku_incoming_nodes_log_knowledge (NetsukukuIncomingNodes* self, NetsukukuNIP* nip, gint nodeid, gint my_seq_num, NetsukukuRoutesSet* destinations, GError** error) {
	NetsukukuNIP* _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* k;
	GeeHashMap* _tmp3_;
	const gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	GeeHashMap* _tmp7_;
	const gchar* _tmp8_;
	gpointer _tmp9_ = NULL;
	NetsukukuIncomingNode* _tmp10_;
	gint _tmp11_;
	NetsukukuRoutesSet* _tmp12_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (nip != NULL);
	g_return_if_fail (destinations != NULL);
	_tmp0_ = nip;
	_tmp1_ = nodeid;
	_tmp2_ = netsukuku_incoming_nodes_tnip_nodeid_key (self, _tmp0_, _tmp1_);
	k = _tmp2_;
	_tmp3_ = self->priv->cont;
	_tmp4_ = k;
	_tmp5_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, _tmp4_);
	if (!_tmp5_) {
		GError* _tmp6_;
		_tmp6_ = g_error_new_literal (NETSUKUKU_INCOMING_NODES_ERROR, NETSUKUKU_INCOMING_NODES_ERROR_KEY_NOT_FOUND, "IncomingNode not present");
		_inner_error_ = _tmp6_;
		if (_inner_error_->domain == NETSUKUKU_INCOMING_NODES_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (k);
			return;
		} else {
			_g_free0 (k);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp7_ = self->priv->cont;
	_tmp8_ = k;
	_tmp9_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, _tmp8_);
	_tmp10_ = (NetsukukuIncomingNode*) _tmp9_;
	_tmp11_ = my_seq_num;
	_tmp12_ = destinations;
	netsukuku_incoming_node_log_knowledge (_tmp10_, _tmp11_, _tmp12_);
	_g_object_unref0 (_tmp10_);
	_g_free0 (k);
}


NetsukukuRoutesSet* netsukuku_incoming_nodes_get_knowledge (NetsukukuIncomingNodes* self, NetsukukuNIP* nip, gint nodeid, gint prev_seq_num, GError** error) {
	NetsukukuRoutesSet* result = NULL;
	NetsukukuNIP* _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* k;
	GeeHashMap* _tmp3_;
	const gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	GeeHashMap* _tmp7_;
	const gchar* _tmp8_;
	gpointer _tmp9_ = NULL;
	NetsukukuIncomingNode* _tmp10_;
	gint _tmp11_;
	NetsukukuRoutesSet* _tmp12_ = NULL;
	NetsukukuRoutesSet* _tmp13_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (nip != NULL, NULL);
	_tmp0_ = nip;
	_tmp1_ = nodeid;
	_tmp2_ = netsukuku_incoming_nodes_tnip_nodeid_key (self, _tmp0_, _tmp1_);
	k = _tmp2_;
	_tmp3_ = self->priv->cont;
	_tmp4_ = k;
	_tmp5_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, _tmp4_);
	if (!_tmp5_) {
		GError* _tmp6_;
		_tmp6_ = g_error_new_literal (NETSUKUKU_INCOMING_NODES_ERROR, NETSUKUKU_INCOMING_NODES_ERROR_KEY_NOT_FOUND, "IncomingNode not present");
		_inner_error_ = _tmp6_;
		if (_inner_error_->domain == NETSUKUKU_INCOMING_NODES_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (k);
			return NULL;
		} else {
			_g_free0 (k);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp7_ = self->priv->cont;
	_tmp8_ = k;
	_tmp9_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, _tmp8_);
	_tmp10_ = (NetsukukuIncomingNode*) _tmp9_;
	_tmp11_ = prev_seq_num;
	_tmp12_ = netsukuku_incoming_node_get_knowledge (_tmp10_, _tmp11_);
	_tmp13_ = _tmp12_;
	_g_object_unref0 (_tmp10_);
	result = _tmp13_;
	_g_free0 (k);
	return result;
}


static void netsukuku_incoming_nodes_class_init (NetsukukuIncomingNodesClass * klass) {
	netsukuku_incoming_nodes_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (NetsukukuIncomingNodesPrivate));
	G_OBJECT_CLASS (klass)->finalize = netsukuku_incoming_nodes_finalize;
	g_signal_new ("incoming_node_updated", NETSUKUKU_TYPE_INCOMING_NODES, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}


static void netsukuku_incoming_nodes_instance_init (NetsukukuIncomingNodes * self) {
	self->priv = NETSUKUKU_INCOMING_NODES_GET_PRIVATE (self);
}


static void netsukuku_incoming_nodes_finalize (GObject* obj) {
	NetsukukuIncomingNodes * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETSUKUKU_TYPE_INCOMING_NODES, NetsukukuIncomingNodes);
	_g_object_unref0 (self->priv->cont);
	G_OBJECT_CLASS (netsukuku_incoming_nodes_parent_class)->finalize (obj);
}


GType netsukuku_incoming_nodes_get_type (void) {
	static volatile gsize netsukuku_incoming_nodes_type_id__volatile = 0;
	if (g_once_init_enter (&netsukuku_incoming_nodes_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NetsukukuIncomingNodesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) netsukuku_incoming_nodes_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetsukukuIncomingNodes), 0, (GInstanceInitFunc) netsukuku_incoming_nodes_instance_init, NULL };
		GType netsukuku_incoming_nodes_type_id;
		netsukuku_incoming_nodes_type_id = g_type_register_static (G_TYPE_OBJECT, "NetsukukuIncomingNodes", &g_define_type_info, 0);
		g_once_init_leave (&netsukuku_incoming_nodes_type_id__volatile, netsukuku_incoming_nodes_type_id);
	}
	return netsukuku_incoming_nodes_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



