/* counter_utils.c generated by valac 0.20.1, the Vala compiler
 * generated from counter_utils.vala, do not modify */

/*
 *  This file is part of Netsukuku.
 *  (c) Copyright 2011-2014 Luca Dionisi aka lukisi <luca.dionisi@gmail.com>
 *
 *  Netsukuku is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Netsukuku is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Netsukuku.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <netsukuku-rpc.h>
#include <zcd.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))



GeeArrayList* netsukuku_counter_utilities_hash_names (GeeArrayList* myhostnames);
gchar* netsukuku_andna_crypto_hash (const gchar* hostname);
guchar* netsukuku_counter_utilities_prepare_msg (NetsukukuNIP* nip, GeeList* hashed_domains, int* result_length1);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


GeeArrayList* netsukuku_counter_utilities_hash_names (GeeArrayList* myhostnames) {
	GeeArrayList* result = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* hashednames;
	g_return_val_if_fail (myhostnames != NULL, NULL);
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL);
	hashednames = _tmp0_;
	{
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
		GeeArrayList* _name_list;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _name_size;
		gint _name_index;
		_tmp1_ = myhostnames;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_name_list = _tmp2_;
		_tmp3_ = _name_list;
		_tmp4_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_name_size = _tmp5_;
		_name_index = -1;
		while (TRUE) {
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			GeeArrayList* _tmp9_;
			gint _tmp10_;
			gpointer _tmp11_ = NULL;
			gchar* name;
			GeeArrayList* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_ = NULL;
			gchar* _tmp15_;
			_tmp6_ = _name_index;
			_name_index = _tmp6_ + 1;
			_tmp7_ = _name_index;
			_tmp8_ = _name_size;
			if (!(_tmp7_ < _tmp8_)) {
				break;
			}
			_tmp9_ = _name_list;
			_tmp10_ = _name_index;
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
			name = (gchar*) _tmp11_;
			_tmp12_ = hashednames;
			_tmp13_ = name;
			_tmp14_ = netsukuku_andna_crypto_hash (_tmp13_);
			_tmp15_ = _tmp14_;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp15_);
			_g_free0 (_tmp15_);
			_g_free0 (name);
		}
		_g_object_unref0 (_name_list);
	}
	result = hashednames;
	return result;
}


guchar* netsukuku_counter_utilities_prepare_msg (NetsukukuNIP* nip, GeeList* hashed_domains, int* result_length1) {
	guchar* result = NULL;
	NetsukukuNIP* _tmp0_;
	gint _tmp1_ = 0;
	guchar* _tmp2_ = NULL;
	guchar* message1;
	gint message1_length1;
	gint _message1_size_;
	GeeList* _tmp3_;
	zcdListString* _tmp4_;
	zcdListString* _tmp5_;
	gint _tmp6_ = 0;
	guchar* _tmp7_ = NULL;
	guchar* _tmp8_;
	gint _tmp8__length1;
	guchar* message2;
	gint message2_length1;
	gint _message2_size_;
	guchar* _tmp9_;
	gint _tmp9__length1;
	guchar* _tmp10_;
	gint _tmp10__length1;
	guchar* _tmp11_ = NULL;
	guchar* message;
	gint message_length1;
	gint _message_size_;
	gint im;
	guchar* _tmp34_;
	gint _tmp34__length1;
	g_return_val_if_fail (nip != NULL, NULL);
	g_return_val_if_fail (hashed_domains != NULL, NULL);
	_tmp0_ = nip;
	_tmp2_ = netsukuku_partial_nip_hash_for_signature ((NetsukukuPartialNIP*) _tmp0_, &_tmp1_);
	message1 = _tmp2_;
	message1_length1 = _tmp1_;
	_message1_size_ = message1_length1;
	_tmp3_ = hashed_domains;
	_tmp4_ = zcd_list_string_new_with_backer (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp7_ = zcd_list_string_hash_for_signature (_tmp5_, &_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp8__length1 = _tmp6_;
	_g_object_unref0 (_tmp5_);
	message2 = _tmp8_;
	message2_length1 = _tmp8__length1;
	_message2_size_ = message2_length1;
	_tmp9_ = message1;
	_tmp9__length1 = message1_length1;
	_tmp10_ = message2;
	_tmp10__length1 = message2_length1;
	_tmp11_ = g_new0 (guchar, _tmp9__length1 + _tmp10__length1);
	message = _tmp11_;
	message_length1 = _tmp9__length1 + _tmp10__length1;
	_message_size_ = message_length1;
	im = 0;
	{
		gint i;
		i = 0;
		{
			gboolean _tmp12_;
			_tmp12_ = TRUE;
			while (TRUE) {
				gboolean _tmp13_;
				gint _tmp15_;
				guchar* _tmp16_;
				gint _tmp16__length1;
				guchar* _tmp17_;
				gint _tmp17__length1;
				gint _tmp18_;
				guchar* _tmp19_;
				gint _tmp19__length1;
				gint _tmp20_;
				guchar _tmp21_;
				guchar _tmp22_;
				_tmp13_ = _tmp12_;
				if (!_tmp13_) {
					gint _tmp14_;
					_tmp14_ = i;
					i = _tmp14_ + 1;
				}
				_tmp12_ = FALSE;
				_tmp15_ = i;
				_tmp16_ = message1;
				_tmp16__length1 = message1_length1;
				if (!(_tmp15_ < _tmp16__length1)) {
					break;
				}
				_tmp17_ = message;
				_tmp17__length1 = message_length1;
				_tmp18_ = im;
				im = _tmp18_ + 1;
				_tmp19_ = message1;
				_tmp19__length1 = message1_length1;
				_tmp20_ = i;
				_tmp21_ = _tmp19_[_tmp20_];
				_tmp17_[_tmp18_] = _tmp21_;
				_tmp22_ = _tmp17_[_tmp18_];
			}
		}
	}
	{
		gint i;
		i = 0;
		{
			gboolean _tmp23_;
			_tmp23_ = TRUE;
			while (TRUE) {
				gboolean _tmp24_;
				gint _tmp26_;
				guchar* _tmp27_;
				gint _tmp27__length1;
				guchar* _tmp28_;
				gint _tmp28__length1;
				gint _tmp29_;
				guchar* _tmp30_;
				gint _tmp30__length1;
				gint _tmp31_;
				guchar _tmp32_;
				guchar _tmp33_;
				_tmp24_ = _tmp23_;
				if (!_tmp24_) {
					gint _tmp25_;
					_tmp25_ = i;
					i = _tmp25_ + 1;
				}
				_tmp23_ = FALSE;
				_tmp26_ = i;
				_tmp27_ = message2;
				_tmp27__length1 = message2_length1;
				if (!(_tmp26_ < _tmp27__length1)) {
					break;
				}
				_tmp28_ = message;
				_tmp28__length1 = message_length1;
				_tmp29_ = im;
				im = _tmp29_ + 1;
				_tmp30_ = message2;
				_tmp30__length1 = message2_length1;
				_tmp31_ = i;
				_tmp32_ = _tmp30_[_tmp31_];
				_tmp28_[_tmp29_] = _tmp32_;
				_tmp33_ = _tmp28_[_tmp29_];
			}
		}
	}
	_tmp34_ = message;
	_tmp34__length1 = message_length1;
	if (result_length1) {
		*result_length1 = _tmp34__length1;
	}
	result = _tmp34_;
	message2 = (g_free (message2), NULL);
	message1 = (g_free (message1), NULL);
	return result;
}



